unit fTestClntMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComObj, TestSrv_TLB, DB, DBClient, MConnect, SConnect, StdCtrls, ActiveX,
  ExtCtrls;

const
  TESTCLNT_TXT: string = 'TESTCLNT.TXT';

type
  TClnt = class(TAutoIntfObject, ITestClntCallback)
  protected
    FOwner: TComponent;
    procedure Progress(percent: Single; out Stop: WordBool); safecall;
    procedure Done; safecall;
    procedure Stopped; safecall;
  public
    constructor Create(AOwner: TComponent; const TypeLib: ITypeLib; const DispIntf: TGUID);
  end;

  TfrmTestClntMain = class(TForm)
    SocketConnection1: TSocketConnection;
    Panel1: TPanel;
    Label2: TLabel;
    Edit1: TEdit;
    Label3: TLabel;
    Edit2: TEdit;
    Panel2: TPanel;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    FClnt: TClnt;
    FDuringAction: Boolean;
    procedure LoadParam;
    procedure SaveParam;
  end;

var
  frmTestClntMain: TfrmTestClntMain;

implementation

{$R *.dfm}

{ TClnt }

constructor TClnt.Create(AOwner: TComponent; const TypeLib: ITypeLib; const DispIntf: TGUID);
begin
  inherited Create(TypeLib,DispIntf);
  FOwner := AOwner;
end;

procedure TClnt.Done;
begin
  ShowMessage('Done');
end;

procedure TClnt.Stopped;
begin
  ShowMessage('Stopped');
end;

procedure TClnt.Progress(percent: Single; out Stop: WordBool);
begin
  with TfrmTestClntMain(FOwner) do
  begin
    Label1.Caption := '';
    Stop := CheckBox1.Checked;
    Label1.Caption := Format('%.2f%%',[percent]);
    Label1.Update;
  end;
  Application.ProcessMessages;
end;

{ TfrmTestClntMain }

procedure TfrmTestClntMain.Button1Click(Sender: TObject);
  procedure OnOffControls(IsEnabled: Boolean);
  begin
    Panel1.Enabled := IsEnabled;
    Button1.Enabled := IsEnabled;
    Button2.Enabled := IsEnabled;
  end;
var
  typelib: ITypeLib;
begin
  OnOffControls(False);
  try
    FDuringAction := True;
    try
      SocketConnection1.Host := Edit1.Text;
      SocketConnection1.Port := StrToIntDef(Edit2.Text,211);

      SocketConnection1.Open;
      try
        OleCheck(LoadRegTypeLib(LIBID_TestSrv,1,0,0,typelib));
        FClnt := TClnt.Create(Self,typelib,ITestClntCallback);
        SocketConnection1.AppServer.SetCallback(FClnt as IDispatch);
        if SocketConnection1.Connected then
        begin
          case TComponent(Sender).Tag of
            1001: SocketConnection1.AppServer.TEST1;
            1002: SocketConnection1.AppServer.TEST2;
          end;
        end;
      finally
        SocketConnection1.Close;
      end;

    finally
      FDuringAction := False;
    end;
  finally
    OnOffControls(True);
  end;
  CheckBox1.Checked := False;
end;

procedure TfrmTestClntMain.FormCreate(Sender: TObject);
begin
  Button1.Tag := 1001;
  Button2.Tag := 1002;
  SocketConnection1.ServerName := 'TestSrv.ITestClnt';
  SocketConnection1.SupportCallbacks := True;
  LoadParam;

end;

procedure TfrmTestClntMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := not FDuringAction;
  if CanClose then
  begin
    SocketConnection1.Close;
    SaveParam;
  end;
end;

procedure TfrmTestClntMain.LoadParam;
var
  L: TStringList;
begin
  L := TStringList.Create;
  try
    if FileExists(TESTCLNT_TXT) then
      L.LoadFromFile(TESTCLNT_TXT);
    Edit1.Text := L.Values['TheHost'];
    Edit2.Text := L.Values['ThePort'];
    if Edit1.Text = '' then Edit1.Text := '127.0.0.1';
    if Edit2.Text = '' then Edit2.Text := '211';
    L.SaveToFile(TESTCLNT_TXT);
  finally
    FreeAndNil(L);
  end;
end;

procedure TfrmTestClntMain.SaveParam;
var
  L: TStringList;
begin
  L := TStringList.Create;
  try
    L.Values['TheHost'] := Edit1.Text;
    L.Values['ThePort'] := Edit2.Text;
  finally
    L.SaveToFile(TESTCLNT_TXT);
  end;
end;

end.


